## ocamlbricks 0.90%2Bbzr400

=== debian/control ===
Source: ocamlbricks
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Lucas Nussbaum <lucas@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends: debhelper (>= 8),
 ocaml-nox (>= 3.12.1),
 liblablgtk2-ocaml-dev (>= 2.12.0-2),
 bash (>= 3.1),
 dh-ocaml (>= 0.9.1),
 ocaml-findlib,
 bzr,
 camlp4-extra
Standards-Version: 3.9.4
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocamlbricks.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocamlbricks.git
Homepage: https://launchpad.net/ocamlbricks

Package: libocamlbricks-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}, liblablgtk2-ocaml-dev (>= 2.12.0-2)
Provides: ${ocaml:Provides}
Replaces: ocamlbricks (<< 0.50.1)
Suggests: ocaml-findlib
Description: Miscellaneous utility functions in OCaml for Marionnet
 This OCaml library provides a set of needed and useful macros for developing.
 It is mainly used by the marionnet package.
 Modules and functionality are the following :
 .
  - Configuration_files: Allow to get information from configuration files
  - Environments: Environments are useful for maintaining the state, intendend 
 as a set of bindings, of a user interaction with a GUI
  - FilenameExtra: Additional features for the standard module Filename
  - Fix: Poor man fix point operators
  - Hashm[m]ap: 2 Module implementing polymorphic unbounded (multi) maps
  - Hashset: Very simple module implementing a polymorphic unbounded sets
  - Identifier: Build and manage unique (fresh) identifiers
  - Ledgrid: Constants Some global constant definitions, for fine-tuning
  - ListExtra: Additional features for the standard module List
  - Memo: Module for building memoised functions
  - Oomarshal: Object-oriented marshalling support
  - PreludeExtra: "Additional features" for the standard module Pervasives
  - Shell: A collection of (mainly quick and easy) wrappers for the most 
 famous Unix tools and generic unix commands or scripts
  - StrExtra: Additional features for the standard library Str
  - Sugar: Basic shortcuts and syntactic sugar
  - SysExtra: Additional features for the standard module Sys
  - UnixExtra: Additional features for the standard library Unix
  - Widget: Some generic tools for building GUIs
  - Wrapper: Handling shell scripts in OCaml
