## ocamlbricks 0.90+bzr367

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 # This -*- makefile -*- is part of our build system for OCaml projects
-# Copyright (C) 2008  Luca Saiu
-# Copyright (C) 2008  Jean-Vincent Loddo
+# Copyright (C) 2008, 2009  Luca Saiu
+# Copyright (C) 2008, 2010  Jean-Vincent Loddo
+# Copyright (C) 2008, 2009, 2010  Université Paris 13
 # Updated in 2008 by Jonathan Roudiere
 
 # This program is free software: you can redistribute it and/or modify
@@ -38,10 +39,19 @@
 SHELL=/bin/bash
 
 OCAMLBUILD = $$( $(call OCAMLBUILD_COMMAND_LINE) )
+LIBRARYPREFIX=$(shell $(call READ_CONFIG, libraryprefix); echo $$libraryprefix)
+OCAML_LIBRARYPREFIX=$(shell $(call READ_CONFIG, ocaml_libraryprefix); echo $$ocaml_libraryprefix)
 
 # The main target. Its implementation is entirely project-dependant:
-main: ocamlbuild-stuff main-local data libraries programs documentation
+main: ocamlbuild-stuff manually_pre_actions main-local data libraries programs manually_post_actions
 	@(echo "Success.")
+
+# Build C modules (no one, by default):
+c-modules:
+	@(mkdir _build &> /dev/null || true) && \
+	for x in $(C_OBJECTS_TO_LINK); do \
+	  make _build/$$x.o; \
+	done
 
 BUILD_FROM_STUFF = \
 	@( echo "Building $(1)..."; \
@@ -62,20 +72,22 @@
 	$(call BUILD_FROM_STUFF, data, $(DATA))
 
 # Build only native libraries:
-native-libraries: ocamlbuild-stuff native-libraries-local $(NATIVE_LIBRARIES)
+native-libraries: ocamlbuild-stuff c-modules native-libraries-local $(NATIVE_LIBRARIES)
 	$(call BUILD_FROM_STUFF, native-libraries, $(NATIVE_LIBRARIES))
 
 # Build only bytecode libraries:
-byte-libraries: ocamlbuild-stuff byte-libraries-local $(BYTE_LIBRARIES)
+byte-libraries: ocamlbuild-stuff c-modules byte-libraries-local $(BYTE_LIBRARIES)
 	$(call BUILD_FROM_STUFF, byte-libraries, $(BYTE_LIBRARIES))
 
 # Build libraries; bytecode, native, or both:
-libraries: libraries-local
+libraries: c-modules libraries-local
 	@($(call BUILD_NATIVE_ANDOR_BYTECODE,libraries) ) # Spaces are ok
 
 # Build programs; bytecode, native, or both:
-programs: programs-local
+# Force the meta.ml regeneration at next make call
+programs: c-modules programs-local
 	@($(call BUILD_NATIVE_ANDOR_BYTECODE,programs) ) # Spaces are ok
+	touch META
 
 # Build the native and/or bytecode version of $(1). $(1) may be either
 # "libraries" or "programs". *Don't* put a space before the argument.
@@ -119,13 +131,97 @@
 world: world-local main
 	@(echo 'Success.')
 
-# Generate ocamldoc documentation:
-ocamldoc: ocamldoc-local
-	@($(call READ_META, name); \
-	$(OCAMLBUILD) $$name.docdir/index.html &> /dev/null && \
-	rm $$name.docdir && \
-	echo 'Success.'; \
-	echo 'The documentation has been built with success under _build/')
+
+############################################################################
+# Support for manually generated files (i.e. not generated with ocamlbuild)
+############################################################################
+
+# Example: (in your Makefile.local)
+#
+# foo.byte   : manually_pre_actions
+# foo.native : manually_pre_actions
+#
+# MANUALLY_PRE_COPY_IN_build = include_as_string_p4.ml USAGE.txt
+# MANUALLY_PRE_MAKE_IN_build = include_as_string_p4.cmo
+#
+# _build/include_as_string_p4.cmo: include_as_string_p4.ml
+#	ocamlc -c -I +camlp4 camlp4lib.cma -pp camlp4of -o $@ $<
+
+.PHONY : manually_pre_actions manually_post_actions
+
+################################# PRE-ACTIONS support
+
+# Files that must be copied in _build/ *before* the ocamlbuild processing.
+MANUALLY_PRE_COPY_IN_build =
+
+# Targets that must be created in _build/ *before* the ocamlbuild processing.
+# For each foo.bar that appears in this list, you have to write a rule
+# _build/foo.bar in your Makefile.local
+MANUALLY_PRE_MAKE_IN_build =
+
+manually_pre_actions:
+	$(call PERFORM_MANUALLY_PRE_ACTIONS, $(MANUALLY_PRE_COPY_IN_build),$(MANUALLY_PRE_MAKE_IN_build))
+
+# Detect if "make clean" is required or copy and build manually targets
+# specified in MANUALLY_PRE_COPY_IN_build and MANUALLY_PRE_MAKE_IN_build
+PERFORM_MANUALLY_PRE_ACTIONS = \
+	@(\
+	if test -d _build/; \
+	then \
+	  echo "Checking if files manually copied in _build/ have been modified..."; \
+	  for x in $(1); do \
+	    echo "Checking \"$$x\"..."; \
+	    test ! -f _build/$$x || \
+	       diff -q $$x _build/$$x 2>/dev/null || \
+	       { echo -e "********************\nmake clean required!\n********************"; exit 1; } ;\
+	  done; \
+	else \
+	  mkdir _build/; \
+	fi; \
+	for x in $(1); do echo "Manually pre-copying \"$$x\"...";  cp --parent -f $$x _build/; done; \
+	for y in $(2); do echo "Manually pre-building \"$$y\"..."; make _build/$$y || exit 1; done; \
+	)
+
+################################# POST-ACTIONS support
+
+# Files that must be copied in _build/ *after* the ocamlbuild processing.
+MANUALLY_POST_COPY_IN_build =
+
+# Targets that must be created in _build/ *after* the ocamlbuild processing.
+# For each foo.bar that appears in this list, you have to write a rule
+# _build/foo.bar in your Makefile.local
+MANUALLY_POST_MAKE_IN_build =
+
+manually_post_actions:
+	$(call PERFORM_MANUALLY_POST_ACTIONS, $(MANUALLY_POST_COPY_IN_build), $(MANUALLY_POST_MAKE_IN_build))
+
+PERFORM_MANUALLY_POST_ACTIONS = \
+	@(\
+	for x in $(1); do echo "Manually post-copying \"$$x\"...";  cp --parent -f $$x _build/; done; \
+	for y in $(2); do echo "Manually post-building \"$$y\"..."; make _build/$$y || exit 1; done; \
+	)
+
+
+
+############################################################################
+# Other entries
+
+
+# Edit all ml/mli files and Makefile.local with your $EDITOR
+edit:
+	test -n "$$EDITOR" && $$EDITOR Makefile.local $$(find . \( -wholename "./_build/*" -o -name "meta.ml" -o -name "$(EXCLUDE_FROM_EDITING)" -o -name "version.ml" -o -name "gui.ml" -o -name myocamlbuild.ml \) -prune -o -type f -a \( -name "*.ml" -o -name "*.mli" \) -print) &
+
+# Create the documentation
+documentation: world documentation-local
+	chmod +x Makefile.d/doc.sh
+	Makefile.d/doc.sh -pp "$(PP_OPTION)" -e "$(UNDOCUMENTED)" -i $(DIRECTORIES_TO_INCLUDE)
+
+doc: documentation
+
+INDEX_HTML=_build/doc/html/index.html
+browse:
+	test -f  $(INDEX_HTML) || make documentation
+	test -n "$$BROWSER" && $$BROWSER $(INDEX_HTML)
 
 # Install programs and libraries:
 install: install-programs install-libraries install-data install-configuration install-documentation install-local
@@ -139,14 +235,14 @@
 # $documentationprefix/$name installation directory:
 OTHER_DOCUMENTATION_TO_INSTALL =
 
-# Install the documentation from this package into $prefix/share/$name:
+# Install the documentation from this package (_build/doc) into $prefix/share/$name:
 install-documentation: install-documentation-local
 	@($(call READ_CONFIG, documentationprefix); \
 	$(call READ_META, name); \
 	directory=$$documentationprefix/$$name; \
 	shopt -s nullglob; \
-	if [ -e doc ]; then \
-	  documentationifany=`ls -d doc/*`; \
+	if [ -e _build/doc ]; then \
+	  documentationifany=`ls -d _build/doc/*`; \
 	else \
 	  documentationifany=''; \
 	fi; \
@@ -233,102 +329,3 @@
 # Uninstall the software configuration files, if any:
 uninstall-configuration: uninstall-configuration-local
 	@($(call READ_CONFIG, configurationprefix); \
-	if [ -e etc ]; then \
-	  echo "Removing configuration files from $$configurationprefix..."; \
-	  shopt -s nullglob; \
-	  for file in etc/*; do \
-	    basename=`basename $$file`; \
-	    echo "Uninstalling $$basename from $$configurationprefix..."; \
-	    if ! rm -f $$configurationprefix/$$basename; then \
-	      echo "ERROR: Could not remove $$basename from $$configurationprefix"; \
-	      exit -1; \
-	    fi; \
-	  done; \
-	else \
-	  echo "We don't have any configuration files to remove."; \
-	fi)
-
-# Remove the data of this package from $prefix/share/$name:
-uninstall-data: uninstall-data-local
-	@( ($(call READ_CONFIG, prefix); \
-	$(call READ_META, name); \
-	directory=$$prefix/share/$$name; \
-	echo "Removing $$name data from $$prefix/share/..."; \
-	shopt -s nullglob; \
-	if rm -rf $$directory; then \
-	  echo "The entire directory $$directory was removed."; \
-	else \
-	  echo "Could not delete $$directory"; \
-	  exit -1; \
-	fi); \
-	echo 'Data uninstallation was successful.')
-
-# Remove the documentation of this package from $documentationprefix/$name:
-uninstall-documentation: documentation uninstall-documentation-local
-	@( ($(call READ_CONFIG, documentationprefix); \
-	$(call READ_META, name); \
-	directory=$$documentationprefix/$$name; \
-	echo "Removing $$name documentation from $$documentationprefix..."; \
-	shopt -s nullglob; \
-	if rm -rf $$directory; then \
-	  echo "The entire directory $$directory was removed."; \
-	else \
-	  echo "Could not delete $$directory"; \
-	  exit -1; \
-	fi); \
-	echo 'Documentation uninstallation was successful.')
-
-# Create the documentation (do nothing by default):
-documentation: documentation-local
-	@(echo 'Success: documentation was build.')
-
-# Just a handy alias:
-doc: documentation
-
-# The user is free to override this to add custom targets to install into the
-# $prefix/bin installation directory; the typical use of this would be
-# installing scripts.
-OTHER_PROGRAMS_TO_INSTALL =
-
-# These are programs to be installed into $prefix/sbin instead of $prefix/bin:
-ROOT_NATIVE_PROGRAMS =
-ROOT_BYTE_PROGRAMS =
-
-# Install the programs from this package into $prefix/bin:
-install-programs: programs install-programs-local
-	@($(call READ_CONFIG, prefix); 		     \
-	$(call READ_META, name);   		     \
-	echo "Creating $$prefix/bin/..."; \
-	(mkdir -p $$prefix/bin &> /dev/null || true); \
-	echo "Creating $$prefix/sbin/..."; \
-	(mkdir -p $$prefix/sbin &> /dev/null || true); \
-	echo "Installing programs from $$name into $$prefix/bin/..."; \
-	shopt -s nullglob; \
-	for file in $(OTHER_PROGRAMS_TO_INSTALL) _build/*.byte _build/*.native; do \
-	  basename=`basename $$file`; \
-	  if echo " $(ROOT_NATIVE_PROGRAMS) $(ROOT_BYTE_PROGRAMS) " | grep -q " $$basename "; then \
-	    echo "Installing "`basename $$file`" as a \"root program\" into $$prefix/sbin..."; \
-	    cp -a $$file $$prefix/sbin/; \
-	  else \
-	    echo "Installing "`basename $$file`" into $$prefix/bin..."; \
-	    cp -a $$file $$prefix/bin/; \
-	  fi; \
-	done) && \
-	echo 'Program installation was successful.'
-
-# Remove the programs from this package from $prefix/bin:
-uninstall-programs: main uninstall-programs-local
-	@($(call READ_CONFIG, prefix); 		     \
-	$(call READ_META, name);   		     \
-	echo "Removing $$name programs..."; \
-	shopt -s nullglob; \
-	for file in $(OTHER_PROGRAMS_TO_INSTALL) _build/*.byte _build/*.native; do \
-	  basename=`basename $$file`; \
-	  if echo " $(ROOT_NATIVE_PROGRAMS) $(ROOT_BYTE_PROGRAMS) " | grep -q " $$basename "; then \
-	    echo -e "Removing the \"root program\" $$basename from $$prefix/sbin..."; \
-	    export pathname=$$prefix/sbin/`basename $$file`; \
-	  else \
-	    echo -e "Removing $$basename from $$prefix/bin..."; \
-	    export pathname=$$prefix/bin/`basename $$file`; \
-	  fi; \
-	  rm -f $$pathname; \
