=== debian/changelog ===
ocamlbricks (0.90+bzr367-1~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- Lucas Nussbaum <lucas@debian.org>  Wed, 10 Jul 2013 10:46:00 +0200

ocamlbricks (0.90+bzr367-1) unstable; urgency=low

  * New upstream snapshot.

 -- Lucas Nussbaum <lucas@debian.org>  Fri, 05 Jul 2013 16:29:21 +0200

ocamlbricks (0.90+bzr365-1) unstable; urgency=low

  * New upstream snapshot from the trunk branch
  * Add myself to Uploaders
  * Update Uploaders to reflect the current state of the package. Thanks,
    Jonathan!
  * Update to Standards-Version 3.9.4 (no changes)
  * Use canonical Git URIs
  * Remove empty directories
  * Add DEP-3 headers for patches

 -- Nicolas Dandrimont <nicolas.dandrimont@crans.org>  Sun, 23 Jun 2013 15:30:45 +0200

ocamlbricks (0.90+bzr364.3-1) unstable; urgency=low

  * New upstream snapshot. Should fix the build failures on
    non-native ocaml architectures.
  * Add no-ocamlopt-arches.diff: work-around for partial upstream fix
    (see https://bugs.launchpad.net/ocamlbricks/+bug/1130098).

 -- Lucas Nussbaum <lucas@debian.org>  Tue, 28 May 2013 16:38:50 +0200

ocamlbricks (0.90+bzr356-1) unstable; urgency=low

  [ Sylvain Le Gall ]
  * Remove Sylvain Le Gall from uploaders

  [ Lucas Nussbaum ]
  * New upstream snapshot from the trunk branch, after discussion with
    upstream author in https://bugs.launchpad.net/marionnet/+bug/1085055.
    This is a step towards packaging marionnet.
  * Rework most of the packaging.
  * Update Standards-Version. No changes needed.
  * New homepage: https://launchpad.net/ocamlbricks

 -- Lucas Nussbaum <lucas@debian.org>  Mon, 18 Feb 2013 21:08:04 +0100

ocamlbricks (0.50.1-4) unstable; urgency=low

  [ Mehdi Dogguy ]
  * Add a .doc-base file for the documentation instead of calling by
    hand ocamldoc-api-ref-config (Closes: #549732).

  [ Sylvain Le Gall ]
  * Use dh_ocaml 0.9 features: OCaml:Provides and OCaml:Depends
  * Downgrade build-depends from ocaml to ocaml-nox
  * Upgrade Standards-Version to 3.8.3 (section ocaml)
  * Add debian/README.source
  * Use ocamlinit.mk (Closes: #521429)

 -- Sylvain Le Gall <gildor@debian.org>  Wed, 07 Oct 2009 09:03:49 +0000

ocamlbricks (0.50.1-3) unstable; urgency=low
  
  [ Jonathan Roudiere ]
  * Change the maintainer of ocamlbricks to Debian OCaml Maintainers
  * Fix bug and compatibility with dash, change 'source' by '.' in
    CONFIGURATION/configuration_files.m and invoke bash explicitly
    in unixExtra.ml
  * miror changes in debian/{rules,control}, update version of
    Debian Policy
  * Solve META lacks dependencies (Closes: #521428)

  [ Sylvain Le Gall ]
  * Add debian/gbp.conf to force using pristine-tar
  * Change debian revision, to match latest uploaded version

  [ Stephane Glondu ]
  * Add dh-ocaml to Build-Depends, update call to ocamldoc-api-ref-config
    (Closes: #519632)
  * Update versions in Build-Depends for OCaml 3.11.0 transition

 -- Sylvain Le Gall <gildor@debian.org>  Sun, 29 Mar 2009 20:13:43 +0200

ocamlbricks (0.50.1-1) unstable; urgency=low

  [ Jonathan Roudiere ]
  * Initial release (closes: Bug#477326) 
    First package of OCamlbricks, including documentation OCamldoc in HTML
    format and the build system use to build OCamlbricks like an example.

  * Creation and adding *.mli (OCaml header files) in the package.

  [ Sylvain Le Gall ]
  * Final fix, review and upload 

 -- Sylvain Le Gall <gildor@debian.org>  Tue, 17 Jun 2008 01:04:30 +0200
