=== debian/changelog ===
ocamlbricks (0.90+bzr400-2) unstable; urgency=medium

  * Team upload
  * Fix a call to Obj.magic that caused segfaults (Closes: #860405)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 20 Apr 2017 13:15:07 +0200

ocamlbricks (0.90+bzr400-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Lucas Nussbaum <lucas@debian.org>  Tue, 08 Jul 2014 11:09:39 +0200

ocamlbricks (0.90+bzr393-1) unstable; urgency=medium

  * New upstream snapshot.
  * Refreshed patches, due to buildsystem changes.
    + Add patch 0004-install-stublibs.patch

 -- Lucas Nussbaum <lucas@debian.org>  Wed, 02 Apr 2014 19:19:00 +0200
