## ocamlbricks 0.90+bzr456

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,10 @@
 # This -*- makefile -*- is part of our build system for OCaml projects
 # Copyright (C) 2008, 2009  Luca Saiu
-# Copyright (C) 2008, 2010  Jean-Vincent Loddo
-# Copyright (C) 2008, 2009, 2010  Université Paris 13
+# Copyright (C) 2008, 2010, 2016  Jean-Vincent Loddo
+# Copyright (C) 2008, 2009, 2010, 2016  Université Paris 13
 # Updated in 2008 by Jonathan Roudiere
+# Thanks to JulioJu (https://github.com/JulioJu) for the patch
+# about prefix_install
 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,8 +19,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-# This is the revision of 2008-04-21.
-
+# This is the revision of 2016-06-07.
 
 ######################################################################
 # This make file is general-purpose: the actual project-dependant part
@@ -40,6 +41,7 @@
 
 OCAMLBUILD = $$( $(call OCAMLBUILD_COMMAND_LINE) )
 LIBRARYPREFIX=$(shell $(call READ_CONFIG, libraryprefix); echo $$libraryprefix)
+OCAML_VERSION=$(shell $(call READ_CONFIG, ocaml_version); echo $$ocaml_version)
 OCAML_LIBRARYPREFIX=$(shell $(call READ_CONFIG, ocaml_libraryprefix); echo $$ocaml_libraryprefix)
 
 # The main target. Its implementation is entirely project-dependant:
@@ -225,14 +227,14 @@
 	@(echo 'Success.')
 
 # The user is free to override this to add custom targets to install into the
-# $prefix/share/$name installation directory:
+# $prefix_install/share/$name installation directory:
 OTHER_DATA_TO_INSTALL =
 
 # The user is free to override this to add custom targets to install into the
 # $documentationprefix/$name installation directory:
 OTHER_DOCUMENTATION_TO_INSTALL =
 
-# Install the documentation from this package (_build/doc) into $prefix/share/$name:
+# Install the documentation from this package (_build/doc) into $prefix_install/share/$name:
 install-documentation: META CONFIGME install-documentation-local
 	@($(call READ_CONFIG, documentationprefix); \
 	$(call READ_META, name); \
@@ -269,11 +271,11 @@
 # Just a handy alias:
 install-doc: install-documentation
 
-# Install the data from this package into $prefix/share/$name:
+# Install the data from this package into $prefix_install/share/$name:
 install-data: META CONFIGME main install-data-local
-	@($(call READ_CONFIG, prefix); \
+	@($(call READ_CONFIG, prefix_install); \
 	$(call READ_META, name); \
-	directory=$$prefix/share/$$name; \
+	directory=$$prefix_install/share/$$name; \
 	shopt -s nullglob; \
 	if [ -e share ]; then \
 	  dataifany=`ls -d share/*`; \
@@ -320,10 +322,3 @@
 	    fi; \
 	  done; \
 	else \
-	  echo "We don't have any configuration files to install."; \
-	fi)
-
-# Uninstall the software configuration files, if any:
-uninstall-configuration: CONFIGME uninstall-configuration-local
-	@($(call READ_CONFIG, configurationprefix); \
-	if [ -e etc ]; then \
