=== debian/changelog ===
ocamlbricks (0.90+bzr456-2build1) focal; urgency=medium

  * No-change rebuild against ocaml-nox-4.08.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Feb 2020 07:32:26 +0000

ocamlbricks (0.90+bzr456-2) unstable; urgency=medium

  * Team upload
  * Update Vcs-*
  * Fix compilation with OCaml 4.08.0

 -- Stéphane Glondu <glondu@debian.org>  Sat, 07 Sep 2019 11:07:40 +0200

ocamlbricks (0.90+bzr456-1) unstable; urgency=medium

  * Refresh patches.
  * Add ocamlbuild to build-depends
  * Run wrap-and-sort -a
  * New upstream version 0.90+bzr456
  * Add breaks on older marionnet
  * Bump debian/compat to 9
  * Bump Standards-version to 4.1.1. No changes needed.
  * Fix FTBFS. Closes: #876734

 -- Lucas Nussbaum <lucas@debian.org>  Mon, 30 Oct 2017 23:05:33 +0100
